/***********************************************************************/
/*                                                                     */
/*  FILE        :oszi_15.c                                             */
/*  DATE        :Wed, Oct 26, 2005                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :Other                                                 */
/*                                                                     */
/*  This file is generated by Renesas Project Generator (Ver.4.0).     */
/*                                                                     */
/*  Einkanal-Scope, R8C/13, 20 MHz, 19200 Baud, 10 Bit, 250 Messungen  */
/*                                                                     */
/***********************************************************************/
                  
#define	AUSGANG 1
#define EINGANG 0

#define RxD1 p3_7
#define TxD1 p0_0
#define pRxD1 pd3_7
#define pTxD1 pd0_0

#define NOP asm ("NOP")

#define buflen 250 //Messwertpufferlnge

#define millisec 5 //Zeitbasis im ms


#include "sfr_r813.h";                  

unsigned int ad_buf[buflen];


/************************************************************************************
Name:        sfr_init
Parameters:  None
Returns:     None
Description: Initial setting of SFR registers
************************************************************************************/
void sfr_init(void){


    /* Setting port registers */
	pRxD1 = EINGANG;
	prc2=1;
	pTxD1 = AUSGANG;
	prc2=1;
	pd0_7 = EINGANG;
	prc2=1;
	
	pd3_2= AUSGANG;


    /* Setting UART registers */
	u1brg = 65-1;	// 19200:0x17, 9600:0x2F (64+1) =  7.372.800 / 16 / 9600 UART0 auf 9600 Baud bei 7,3 MHz (Fehler ist ?)
	u1mr = 0x05;	// 0000.0101 UART1: 8bit; int. CLK; 1 Stop Bit; No parity; No Sleep
					// || | |^^^ 	8 Bit
					// || | ^  	Interne Clock
					// || ^		1 Stop Bit
					// |^		Paritt ausgeschaltet
					// ^		Sleep Mode deaktiviert 

	u1c0 = 0x00;	// 0000.0000 UART1: f1 as CLK; CTS, RTS disabled
					// ||||   ^^ 	f1 is selected as clock
					//    ^    	write 0




	u1c1 = 0x05;	// 0000.0101 UART1: Rx, TX enabled,   00000101
					//       | ^ 	Tx enabled
					//       ^    	Rx enabled


	ucon = 0x20;	//  P00=RXD11,  00100100, 00100000


    /* Set A/D control registers */
	adcon0 = 0x80;	// Diverse Einstellungen
//	adcon1 = 0x38; 	// 10bit-Mode;  Vref; 			!FAD ist gesetzt
    adcon1 = 0x28;                          /* 10-bit mode */
	adcon2 = 0x01;	// Mit Sample & Hold



    /* Set TimerX control registers */
	txck0 = 1; /* Timer X count source = f8 */
	txck1 = 0;
	/* Setting main cycle timer */
	/* 20MHz * 1/8 * 100 * 200 = 2ms */
	prex = 250-1; /* Setting Prescaler X register */
	tx = millisec*10-1; // Setting timer X register 200
	txmr = 0x00; /* Setting timer X mode register = timer mode */
	txs = 1; /* Timer X count start flag = start */
}

void sendTxd1(unsigned char data)
{
	while (ti_u1c1 == 0);	//Wait for transmission buffer emty
	u1tb = data;       	// Set transmission data 
    te_u1c1 = 1;        	// Transmission enabled 
}

unsigned char receiveRxd1 (void)
{
	unsigned char data;
	unsigned char dummy;
	while (ir_s1ric == 0); 	//Wait for received data
    ir_s1ric = 0;    		//Clear serial reception flag 
	data = u1rbl;     		// Get reception data 
	dummy = u1rbh;     		// Get error 
	re_u1c1 = 1;      		// Reception enabled 

	return data;
}

unsigned long ad_in(void)
{
	unsigned int Lauf;
	unsigned int Wert=0;

	for (Lauf=0;Lauf<16;Lauf++)	// 
	{
	    adst = 1;                               /* Conversion start */
	    while(adst == 1){}                      /* Wait A/D conversion */
		NOP;
		NOP;
		Wert=Wert+(ad & 0x03ff);
	}
    return Wert/16;                   /* return AD value */
}

void messung(void)
{
unsigned int adr;

	for (adr = 0; adr < buflen; adr++)
	{
		while(ir_txic == 0){} /* Main cycle 5ms */
		ir_txic = 0;
		ad_buf[adr] = ad_in();
	}	 

	p3_2=0;					// Led off
	for (adr = 0; adr < buflen; adr++)
	{
		sendTxd1(ad_buf[adr] >> 8);
		sendTxd1(ad_buf[adr] & 0xff);
	}
	p3_2=1;					//Led on
}

void main(void)
{

    /*-------------------------------------------------
    -  Change on-chip oscillator clock to Main clock  -
    -------------------------------------------------*/

    prc0 = 1;           	/* Protect off */
    cm13 = 1;           	/* Xin Xout */
    cm15 = 1;           	/* XCIN-XCOUT drive capacity select bit : HIGH */
    cm05 = 0;           	/* Xin on */
    cm16 = 0;           	/* Main clock = No division mode */
    cm17 = 0;
    cm06 = 0;           	/* CM16 and CM17 enable */
    asm("nop");         	/* Waiting for stable of oscillation */
    asm("nop");
    asm("nop");
    asm("nop");
    ocd2 = 0;           	/* Main clock change */
    prc0 = 0;           	/* Protect on */
	sfr_init();  

	p3_2=1;					//Led on

	while (1)
	{  
//	p3_2=1;
		receiveRxd1();
//	p3_2=0;
		messung();
	}
}
