/***********************************************************************/
/*                                                                     */
/*  FILE        :lcd.c                                                 */
/*  DATE        :Mon, Oct 24, 2005                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :Other                                                 */
/*                                                                     */
/*  This file is generated by Renesas Project Generator (Ver.4.0).     */
/*                                                                     */
/***********************************************************************/
 
 #include "sfr_r813.h";                  

static unsigned char Port0;

void delayus (unsigned int micros)
{
	unsigned int i;
	for (i = 0; i < micros; i++)
	{
		asm("nop");
	}
}

void lcddata(unsigned char data)
{
	delayus(100);
	Port0 = data & 0xF0;
	Port0 = Port0 + 0x04;  	//rs = 1
	p0 = Port0;
	p0 = Port0 + 0x08;		//E = 1
	asm("nop");
	p0 = Port0;				//E = 0
	Port0 = ((data & 0x0f)<<4);
	Port0 = Port0 + 0x04;	//rs = 1
	p0 = Port0;
	p0 = Port0 + 0x08;		//E = 1
	asm("nop");
	p0 = Port0;				//E = 0
	delayus (100);
}

void lcdctrl(unsigned char data)
{
	Port0 = data & 0xF0;
	p0 = Port0;
	p0 = Port0 + 0x08;		//E = 1
	asm("nop");
	p0 = Port0;				//E = 0
	Port0 = ((data & 0x0f)<<4);
	Port0 = Port0 + 0x01;
	p0 = Port0;
	p0 = Port0 + 0x08;		//E = 1
	asm("nop");
	p0 = Port0;				//E = 0
	delayus (100);
}

void initlcd (void)
{
	delayus(15000);
	lcdctrl(0x28);
	delayus(5000);
	lcdctrl(0x28);
	delayus(1000);
	lcdctrl(0x28);
	delayus(1000);
	lcdctrl(0x0c);
	delayus(1000);
	lcdctrl(0x01);
	delayus(5000);
}



void lcd_integer (unsigned int data)
{
	unsigned char byt;
	byt = data / 1000;
	data = data - byt * 1000;
	lcddata(byt + 48);
	byt = data / 100;
	data = data - byt * 100;
	lcddata(byt + 48);
	byt = data / 10;
	data = data - byt * 10;
	lcddata(byt + 48);
	lcddata(data + 48); 
}

void lcd_text (char text[20])
{
	unsigned int i;
	i = 0;
	while ((!(text[i] == 0)) & (i < 20))
	{
		lcddata (text[i]);
		i = i + 1;	
	}
}


void lcd_pos (unsigned int Zeile, unsigned int Spalte)
{
	lcdctrl (0x80 + Spalte-1 + 0x40*(Zeile-1));
	//delayus(100);
}



void UART0_init(void){
    p1 = p1 | 0x10;   // TxD0 port output 
    pd1 = pd1 | 0x10; // TxD0 port direction = output 
    pd1 = pd1 & 0xdf; // RxD0 port direction = input 
    u0mr = 0x05;      // UART0 transmit/receive mode 
    u0c0 = 0x00;      // UART0 transmit/receive control 
    u0rrm = 0;        // Continuous receive mode disabled 
    u0brg = 130-1;    // 9600 baud @20MHz 
    re_u0c1 = 1;      // Reception enabled 
}

void sendTxd0(unsigned char data)
{
	while (ti_u0c1 == 0);	//Wait for transmission buffer emty
	u0tbl = data;       	// Set transmission data 
    te_u0c1 = 1;        	// Transmission enabled 
}


unsigned char receiveRxd0 (void)
{
	unsigned char data;
	unsigned char dummy;
	while (ir_s0ric == 0); 	//Wait for received data
    ir_s0ric = 0;    		//Clear serial reception flag 
	data = u0rbl;     		// Get reception data 
	dummy = u0rbh;     		// Get error 
	re_u0c1 = 1;      		// Reception enabled 
	return data;
}

unsigned int ad_in(unsigned char ch)
{
    adcon0 = 0x80 + ch;     //Port P0 group 
    adcon1 = 0x28;          //10-bit mode 
    adst = 1;               //Conversion start 
    while(adst == 1){}      //Wait A/D conversion 
    return ad;              //AD value 
}

void voltmeter()
{
	float u;
	unsigned char c;
	u = (float) ad_in(6); 
	u = u / 1023.0 * 5.0;
	c = u;
	lcddata (c+48);
	sendTxd0 (c+48);
	lcddata (0x2e);
	sendTxd0 (0x2e);
	u = u - c;
	u = u * 10;
	c = u;
	lcddata (c+48);
	sendTxd0 (c+48);
	u = u - c;
	u = u * 10;
	c = u;
	lcddata (c+48);
	sendTxd0 (c+48);
	u = u - c;
	u = u * 10;
	c = u;
	lcddata (c+48);
	lcddata (0x20);
	lcddata (0x56);
	sendTxd0 (c+48);
	sendTxd0 (0x20);
	sendTxd0 (0x56);
	sendTxd0 (0x0d);
}




void main(void)
{
	unsigned char dummy;	
    /*-------------------------------------------------
    -  Change on-chip oscillator clock to Main clock  -
    -------------------------------------------------*/

    prc0 = 1;           	/* Protect off */
    cm13 = 1;           	/* Xin Xout */
    cm15 = 1;           	/* XCIN-XCOUT drive capacity select bit : HIGH */
    cm05 = 0;           	/* Xin on */
    cm16 = 0;           	/* Main clock = No division mode */
    cm17 = 0;
    cm06 = 0;           	/* CM16 and CM17 enable */
    asm("nop");         	/* Waiting for stable of oscillation */
    asm("nop");
    asm("nop");
    asm("nop");
    ocd2 = 0;           	/* Main clock change */
    prc0 = 0;           	/* Protect on */

	Port0 = 0xff;
	p0 = 0xfd;
	prc2 = 1;		//protect off
	pd0 = 0xfd; 	//LCD port, fit 1 input of AD


	UART0_init();  //Test LCD-Init und ABCDEF
	initlcd();
	lcddata (65);
	lcddata (66);
	lcddata (67);
	lcddata (68);
	lcddata (69);
	lcddata (70);

	//test voltmeter
	while  (1)
	{
	    lcd_pos (1,10);
		voltmeter();
		delayus (50000);
	}

	lcd_text ("XYZ");
	lcd_integer(1234);

	//test delayus
	pd1=255;
	while (1)
	{ p1=255;
	  delayus(1000);
	  p1=0;
	  delayus(1000);
	}

	//test UART0
 	while(1) 
    {
		sendTxd0 (receiveRxd0());
	}	


	
	while(1)
	{
		lcd_pos (2,4);
		lcd_integer(ad_in(6));
		delayus(50000);
	}

	while  (1) //test ad_in und lcd_integer
    {
		sendTxd0 (ad_in(6));
		delayus (50000);
		lcdctrl(0x88);
		delayus(1000);
		lcd_integer(ad_in(6));
 		delayus (50000);
   }


 	while  (1) //Test Empfangen an RXD0 und Zurcksenden an TXD0
    {
		sendTxd0 (receiveRxd0());
		delayus (5000);
   }	


}
